diff --git a/target/linux/ar71xx/base-files/etc/board.d/01_leds b/target/linux/ar71xx/base-files/etc/board.d/01_leds
index 5be9d4a..898af5e 100755
--- a/target/linux/ar71xx/base-files/etc/board.d/01_leds
+++ b/target/linux/ar71xx/base-files/etc/board.d/01_leds
@@ -437,6 +437,9 @@ re450)
 	ucidef_set_led_wlan "wlan2g" "WLAN 2.4 GHz" "$board:blue:wlan2g" "phy1tpt"
 	ucidef_set_led_wlan "wlan5g" "WLAN 5 GHz" "$board:blue:wlan5g" "phy0tpt"
 	;;
+sc450)
+	ucidef_set_led_wlan "wlan" "WLAN" "$board:green:wlan" "phy0tpt"
+	;;
 smart-300)
 	ucidef_set_led_netdev "wan" "WAN" "nc-link:green:wan" "eth0"
 	ucidef_set_led_switch "lan1" "LAN1" "nc-link:green:lan1" "switch0" "0x04"
diff --git a/target/linux/ar71xx/base-files/etc/diag.sh b/target/linux/ar71xx/base-files/etc/diag.sh
index 36f2c43..695f0a1 100644
--- a/target/linux/ar71xx/base-files/etc/diag.sh
+++ b/target/linux/ar71xx/base-files/etc/diag.sh
@@ -44,6 +44,7 @@ get_status_led() {
 	mr12|\
 	mr16|\
 	nbg6616|\
+	sc450|\
 	tl-wpa8630)
 		status_led="$board:green:power"
 		;;
diff --git a/target/linux/ar71xx/base-files/lib/ar71xx.sh b/target/linux/ar71xx/base-files/lib/ar71xx.sh
index a8bdc67..a15aab9 100755
--- a/target/linux/ar71xx/base-files/lib/ar71xx.sh
+++ b/target/linux/ar71xx/base-files/lib/ar71xx.sh
@@ -884,6 +884,9 @@ ar71xx_board_detect() {
 	*SC300M)
 		name="sc300m"
 		;;
+	*SC450)
+		name="sc450"
+		;;
 	*"SMART-300")
 		name="smart-300"
 		;;
diff --git a/target/linux/ar71xx/base-files/lib/upgrade/platform.sh b/target/linux/ar71xx/base-files/lib/upgrade/platform.sh
index 74808ef..690f5f2 100755
--- a/target/linux/ar71xx/base-files/lib/upgrade/platform.sh
+++ b/target/linux/ar71xx/base-files/lib/upgrade/platform.sh
@@ -227,6 +227,7 @@ platform_check_image() {
 	rocket-m|\
 	rw2458n|\
 	sc300m|\
+	sc450|\
 	sr3200|\
 	tew-632brp|\
 	tew-712br|\
diff --git a/target/linux/ar71xx/config-4.4 b/target/linux/ar71xx/config-4.4
index daffdea..bdd2179 100644
--- a/target/linux/ar71xx/config-4.4
+++ b/target/linux/ar71xx/config-4.4
@@ -148,6 +148,7 @@ CONFIG_ATH79_MACH_R6100=y
 CONFIG_ATH79_MACH_RE450=y
 CONFIG_ATH79_MACH_RW2458N=y
 CONFIG_ATH79_MACH_SC300M=y
+CONFIG_ATH79_MACH_SC450=y
 CONFIG_ATH79_MACH_SMART_300=y
 CONFIG_ATH79_MACH_SOM9331=y
 CONFIG_ATH79_MACH_SR3200=y
diff --git a/target/linux/ar71xx/files/arch/mips/ath79/Kconfig.openwrt b/target/linux/ar71xx/files/arch/mips/ath79/Kconfig.openwrt
index 56889d7..0fae915 100644
--- a/target/linux/ar71xx/files/arch/mips/ath79/Kconfig.openwrt
+++ b/target/linux/ar71xx/files/arch/mips/ath79/Kconfig.openwrt
@@ -9,6 +9,17 @@ config ATH79_MACH_SC300M
 	select ATH79_DEV_USB
 	select ATH79_DEV_WMAC
 
+config ATH79_MACH_SC450
+	bool "Abicom SC450 board support"
+	select SOC_QCA955X
+	select ATH79_DEV_AP9X_PCI if PCI
+	select ATH79_DEV_ETH
+	select ATH79_DEV_GPIO_BUTTONS
+	select ATH79_DEV_LEDS_GPIO
+	select ATH79_DEV_M25P80
+	select ATH79_DEV_USB
+	select ATH79_DEV_WMAC
+
 config ATH79_MACH_ALFA_AP120C
 	bool "ALFA Network AP120C board support"
 	select ATH79_DEV_AP9X_PCI if PCI
diff --git a/target/linux/ar71xx/files/arch/mips/ath79/Makefile b/target/linux/ar71xx/files/arch/mips/ath79/Makefile
index 915b34e..ae0e007 100644
--- a/target/linux/ar71xx/files/arch/mips/ath79/Makefile
+++ b/target/linux/ar71xx/files/arch/mips/ath79/Makefile
@@ -152,6 +152,7 @@ obj-$(CONFIG_ATH79_MACH_RBSXTLITE)		+= mach-rbsxtlite.o
 obj-$(CONFIG_ATH79_MACH_RE450)			+= mach-re450.o
 obj-$(CONFIG_ATH79_MACH_RW2458N)		+= mach-rw2458n.o
 obj-$(CONFIG_ATH79_MACH_SC300M)			+= mach-sc300m.o
+obj-$(CONFIG_ATH79_MACH_SC450)			+= mach-sc450.o
 obj-$(CONFIG_ATH79_MACH_SMART_300)		+= mach-smart-300.o
 obj-$(CONFIG_ATH79_MACH_SOM9331)		+= mach-som9331.o
 obj-$(CONFIG_ATH79_MACH_SR3200)			+= mach-sr3200.o
diff --git a/target/linux/ar71xx/files/arch/mips/ath79/mach-sc450.c b/target/linux/ar71xx/files/arch/mips/ath79/mach-sc450.c
new file mode 100644
index 0000000..9cd0815
--- /dev/null
+++ b/target/linux/ar71xx/files/arch/mips/ath79/mach-sc450.c
@@ -0,0 +1,149 @@
+/*
+ * Abicom International Scorpion SC450 support.
+ *
+ * Copyright (c) 2012 Qualcomm Atheros
+ * Copyright (c) 2012-2013 Gabor Juhos <juhosg@openwrt.org>
+ * Copyright (c) 2017 Conor O'Gorman <i@conorogorman.net>
+ *
+ * Permission to use, copy, modify, and/or distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ */
+
+#include <linux/platform_device.h>
+#include <linux/platform_data/phy-at803x.h>
+
+#include <asm/mach-ath79/ar71xx_regs.h>
+
+#include "common.h"
+#include "pci.h"
+#include "dev-ap9x-pci.h"
+#include "dev-gpio-buttons.h"
+#include "dev-eth.h"
+#include "dev-leds-gpio.h"
+#include "dev-m25p80.h"
+#include "dev-nfc.h"
+#include "dev-usb.h"
+#include "dev-wmac.h"
+#include "machtypes.h"
+
+#define SC450_GPIO_LED_POWER		13
+#define SC450_GPIO_LED_ERR1		14
+#define SC450_GPIO_LED_ERR2		15
+#define SC450_GPIO_LED_WLAN		16
+#define SC450_GPIO_BTN_RESET		17
+#define SC450_GPIO_WP			18
+#define SC450_GPIO_POE			19
+#define SC450_GPIO_RX_LOS		20
+#define SC450_GPIO_MOD_GND		21
+#define SC450_GPIO_MOD_SCL		22
+#define SC450_GPIO_MOD_SDA		23
+
+#define SC450_KEYS_POLL_INTERVAL	20	/* msecs */
+#define SC450_KEYS_DEBOUNCE_INTERVAL	(3 * SC450_KEYS_POLL_INTERVAL)
+
+#define SC450_MAC0_OFFSET		0
+#define SC450_MAC1_OFFSET		6
+#define SC450_WMAC_CALDATA_OFFSET	0x1000
+#define SC450_PCIE_CALDATA_OFFSET	0x5000
+
+static struct gpio_led sc450_leds_gpio[] __initdata = {
+	{
+		.name		= "sc450:green:power",
+		.gpio		= SC450_GPIO_LED_POWER,
+		.active_low	= 1,
+	},
+	{
+		.name		= "sc450:red:power",
+		.gpio		= SC450_GPIO_LED_ERR1,
+		.active_low	= 1,
+	},
+	{
+		.name		= "sc450:green:wlan",
+		.gpio		= SC450_GPIO_LED_WLAN,
+		.active_low	= 1,
+	},
+	{
+		.name		= "sc450:red:wlan",
+		.gpio		= SC450_GPIO_LED_ERR2,
+		.active_low	= 1,
+	}
+};
+
+static struct gpio_keys_button sc450_gpio_keys[] __initdata = {
+	{
+		.desc		= "reset",
+		.type		= EV_KEY,
+		.code		= KEY_RESTART,
+		.debounce_interval = SC450_KEYS_DEBOUNCE_INTERVAL,
+		.gpio		= SC450_GPIO_BTN_RESET,
+		.active_low	= 1,
+	}
+};
+
+static struct at803x_platform_data at803x_data = {
+	.disable_smarteee = 1,
+	.enable_rgmii_rx_delay = 0,
+	.enable_rgmii_tx_delay = 0,
+};
+
+static struct mdio_board_info sc450_mdio0_info[] = {
+	{
+		.bus_id = "ag71xx-mdio.0",
+		.phy_addr = 1,
+		.platform_data = &at803x_data,
+	},
+};
+
+static void __init sc450_setup(void)
+{
+	u8 *art = (u8 *) KSEG1ADDR(0x1fff0000);
+
+	ath79_register_m25p80(NULL);
+
+	ath79_register_leds_gpio(-1, ARRAY_SIZE(sc450_leds_gpio),
+				 sc450_leds_gpio);
+	ath79_register_gpio_keys_polled(-1, SC450_KEYS_POLL_INTERVAL,
+					ARRAY_SIZE(sc450_gpio_keys),
+					sc450_gpio_keys);
+
+	ath79_register_usb();
+	ath79_register_nfc();
+
+	ath79_register_wmac(art + SC450_WMAC_CALDATA_OFFSET, NULL);
+
+	ath79_register_mdio(0, 0);
+	mdiobus_register_board_info(sc450_mdio0_info,
+				    ARRAY_SIZE(sc450_mdio0_info));
+
+	ath79_init_mac(ath79_eth0_data.mac_addr, art + SC450_MAC0_OFFSET, 0);
+
+	ath79_eth0_pll_data.pll_1000 = 0xa6000101;
+	ath79_eth0_pll_data.pll_100 = 0xa4000101;
+	/* GMAC0 is connected to the RMGII interface */
+	ath79_eth0_data.phy_if_mode = PHY_INTERFACE_MODE_RGMII;
+	ath79_eth0_data.phy_mask = 0xF;
+	ath79_eth0_data.mii_bus_dev = &ath79_mdio0_device.dev;
+
+	ath79_register_eth(0);
+
+	/* GMAC1 is connected to the SGMII interface */
+	ath79_eth1_data.phy_if_mode = PHY_INTERFACE_MODE_SGMII;
+	ath79_eth1_data.speed = SPEED_1000;
+	ath79_eth1_data.duplex = DUPLEX_FULL;
+
+	ath79_register_eth(1);
+
+	ath79_register_pci();
+}
+
+MIPS_MACHINE(ATH79_MACH_SC450, "SC450", "Abicom SC450", sc450_setup);
diff --git a/target/linux/ar71xx/files/arch/mips/ath79/machtypes.h b/target/linux/ar71xx/files/arch/mips/ath79/machtypes.h
index b1e29f9..da9c160 100644
--- a/target/linux/ar71xx/files/arch/mips/ath79/machtypes.h
+++ b/target/linux/ar71xx/files/arch/mips/ath79/machtypes.h
@@ -169,6 +169,7 @@ enum ath79_mach_type {
 	ATH79_MACH_RE450,			/* TP-LINK RE450 */
 	ATH79_MACH_RW2458N,			/* Redwave RW2458N */
 	ATH79_MACH_SC300M,			/* Abicom SC300M */
+	ATH79_MACH_SC450,			/* Abicom SC450 */
 	ATH79_MACH_SMART_300,			/* NC-LINK SMART-300 */
 	ATH79_MACH_SOM9331,			/* OpenEmbed SOM9331 */
 	ATH79_MACH_SR3200,			/* YunCore SR3200 */
diff --git a/target/linux/ar71xx/image/generic.mk b/target/linux/ar71xx/image/generic.mk
index f8445b5..02b90b0 100644
--- a/target/linux/ar71xx/image/generic.mk
+++ b/target/linux/ar71xx/image/generic.mk
@@ -474,6 +474,16 @@ define Device/sc300m
 endef
 TARGET_DEVICES += sc300m
 
+define Device/sc450
+  DEVICE_TITLE := Abicom SC450
+  DEVICE_PACKAGES := kmod-usb-core kmod-usb-ohci kmod-usb2 kmod-usb-ledtrig-usbport
+  BOARDNAME = SC450
+  IMAGE_SIZE = 15744k
+  CONSOLE = ttyS0,115200
+  MTDPARTS = spi0.0:256k(u-boot)ro,64k(u-boot-env),15744k(firmware),128k(APConfig),128k(kplog),64k(ART)
+endef
+TARGET_DEVICES += sc450
+
 define Device/smart-300
   $(Device/tplink-8mlzma)
   DEVICE_TITLE := NC-LINK SMART-300